#include <stdio.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include <exec/types.h>

#define ScrnWidth 640
#define ScrnHeight 200
#define ScrnFlags HIRES

#define POINTS 10

#define malloc mymalloc
#define free myfree
#define realloc myrealloc
 
struct pts
    {
    short p[1][2];
    };

struct line
    {
    short box[2][2];
    struct line *next;
    short linec,fillc;/* negative fill color means transparent */
    struct pts *pts;
    short number;
    };

struct object
    {
    short offset[2];
    struct line *image,*skeleton,*outline;
    struct object *frameup,*framedown,*next,*prev;
    short entry,ilaw;
    };

typedef struct line * line_ptr;
typedef struct object * obj_ptr;

/* entry flags */
#define IMAGE 1
#define SKELETON 2
#define XOUTLINE 4
/* additional displaymode flags */
#define ENTRY 0
#define ALL IMAGE|SKELETON|XOUTLINE
/* additional drawmode flags */
#define FILL 8

/* ilaw flags */
#define XACCEL 1
#define YACCEL 2
#define XDECEL 4
#define YDECEL 8

/* displayflags */
#define DISPIMAGE 0
#define DISPALL 1
#define DISPENTRY 2


#include "funcs.h"
#include "globals.h"
